' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Dim objDSE, strDefaultDN, strDN, objADObject, i
Dim objSecDesc, objDACL, objACE, objExcel

Set objDSE = GetObject("LDAP://rootDSE")
strDefaultDN = "CN=Users," & objDSE.Get("defaultNamingContext")

strDN = 	InputBox("Enter the distinguished name of an object" & _
	vbCrLf & "(e.g. " & strDefaultDN & ")", , strDefaultDN)

If strDN = "" Then WScript.Quit(0)  'user clicked Cancel

Set objADObject = GetObject("LDAP://" & strDN)

Set objSecDesc = objADObject.Get("ntSecurityDescriptor")
Set objDACL = objSecDesc.DiscretionaryAcl

Set objExcel = WScript.CreateObject("Excel.Application")
objExcel.Visible = True
objExcel.Workbooks.Add
objExcel.ActiveSheet.Name = "ACEs"

objExcel.ActiveSheet.Range("A1").Activate
objExcel.ActiveCell.Value = "Trustee"
objExcel.ActiveCell.Offset(0,1).Value = "AccessMask"
objExcel.ActiveCell.Offset(0,2).Value = "AceFlags"
objExcel.ActiveCell.Offset(0,3).Value = "AceType"
objExcel.ActiveCell.Offset(0,4).Value = "Flags"
objExcel.ActiveCell.Offset(0,5).Value = "ObjectType"
objExcel.ActiveCell.Offset(0,6).Value = "InheritedObjectType"
objExcel.ActiveCell.Offset(1,0).Activate  'goto next line

i = 0
For Each objACE In objDACL
	objExcel.ActiveCell.Value = objACE.Trustee
	objExcel.ActiveCell.Offset(0,1).Value = Hex(objACE.AccessMask)
	objExcel.ActiveCell.Offset(0,2).Value = Hex(objACE.AceFlags)
	objExcel.ActiveCell.Offset(0,3).Value = Hex(objACE.AceType)
	objExcel.ActiveCell.Offset(0,4).Value = Hex(objACE.Flags)
	objExcel.ActiveCell.Offset(0,5).Value = objACE.ObjectType
	objExcel.ActiveCell.Offset(0,6).Value = objACE.InheritedObjectType
	objExcel.ActiveCell.Offset(1,0).Activate  'goto next line
Next
