' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Dim objDSE, strDefaultDN, strDN, objContainer, objChild

Set objDSE = GetObject("LDAP://rootDSE")
strDefaultDN = objDSE.Get("defaultNamingContext")

strDN = 	InputBox("Enter the distinguished name of a container" & _
	vbCrLf & "(e.g. " & strDefaultDN & ")", , strDefaultDN)

If strDN = "" Then WScript.Quit(1)		'user clicked Cancel

Set objContainer = GetObject("LDAP://" & strDN)
Call ListUsers(objContainer)

Sub ListUsers(objADObject)
	Dim objChild
	For Each objChild in objADObject
		Select Case objChild.Class
			Case "user"
				WScript.Echo objChild.Name & vbTab & _
					objChild.Get("distinguishedName")
			Case "organizationalUnit" , "container"
				Call ListUsers(objChild)
		End select
	Next
End Sub
